## cloud-init 22.2

=== Makefile ===
CWD=$(shell pwd)
VARIANT ?= ubuntu

YAML_FILES=$(shell find cloudinit tests tools -name "*.yaml" -type f )
YAML_FILES+=$(shell find doc/examples -name "cloud-config*.txt" -type f )

PYTHON = python3
PIP_INSTALL := pip3 install

NUM_ITER ?= 100

ifeq ($(distro),)
  distro = redhat
endif

READ_VERSION=$(shell $(PYTHON) $(CWD)/tools/read-version || echo read-version-failed)
CODE_VERSION=$(shell $(PYTHON) -c "from cloudinit import version; print(version.version_string())")
GENERATOR_F=./systemd/cloud-init-generator
DS_IDENTIFY=./tools/ds-identify
BENCHMARK=./tools/benchmark.sh


all: check

check: check_version test yaml

style-check: flake8

flake8:
	@$(CWD)/tools/run-flake8

unittest: clean_pyc
	python3 -m pytest -v tests/unittests cloudinit

render-template:
	$(PYTHON) ./tools/render-cloudcfg --variant=$(VARIANT) $(FILE) $(subst .tmpl,,$(FILE))

# from systemd-generator(7) regarding generators:
# "We do recommend C code however, since generators are executed
# synchronously and hence delay the entire boot if they are slow."
#
# Our generator is a shell script. Make it easy to measure the
# generator. This should be monitored for performance regressions
benchmark-generator: FILE=$(GENERATOR_F).tmpl
benchmark-generator: export ITER=$(NUM_ITER)
benchmark-generator: render-template
	$(BENCHMARK) $(GENERATOR_F)

benchmark-ds-identify: export ITER=$(NUM_ITER)
benchmark-ds-identify:
	$(BENCHMARK) $(DS_IDENTIFY)

ci-deps-ubuntu:
	@$(PYTHON) $(CWD)/tools/read-dependencies --distro ubuntu --test-distro

ci-deps-centos:
	@$(PYTHON) $(CWD)/tools/read-dependencies --distro centos --test-distro

pip-requirements:
	@echo "Installing cloud-init dependencies..."
	$(PIP_INSTALL) -r "$@.txt" -q

pip-test-requirements:
	@echo "Installing cloud-init test dependencies..."
	$(PIP_INSTALL) -r "$@.txt" -q

test: unittest

check_version:
	@if [ "$(READ_VERSION)" != "$(CODE_VERSION)" ]; then \
		echo "Error: read-version version '$(READ_VERSION)'" \
			"not equal to code version '$(CODE_VERSION)'"; \
		exit 2; \
	else true; fi

config/cloud.cfg:
	$(PYTHON) ./tools/render-cloudcfg config/cloud.cfg.tmpl config/cloud.cfg

clean_pyc:
	@find . -type f -name "*.pyc" -delete
	@find . -type d -name __pycache__ -delete

clean_pytest:
	rm -rf .cache htmlcov

clean_packaging:
	rm -rf srpm cloud_init.egg-info/ \
		cloud-init-*.tar.gz \
		cloud-init-*.tar.gz.asc \
		cloud-init.dsc \
		cloud-init_*.build \
		cloud-init_*.buildinfo \
		cloud-init_*.changes \
		cloud-init_*.deb \
		cloud-init_*.dsc \
		cloud-init_*.orig.tar.gz \
		cloud-init_*.tar.xz \
		cloud-init_*.upload

clean_release:
	rm -rf new-upstream-changes.txt commit.msg

clean: clean_pyc clean_pytest clean_packaging clean_release
	rm -rf doc/rtd_html .tox .coverage tags $(GENERATOR_F)

yaml:
	@$(PYTHON) $(CWD)/tools/validate-yaml.py $(YAML_FILES)

rpm:
	$(PYTHON) ./packages/brpm --distro=$(distro)

srpm:
	$(PYTHON) ./packages/brpm --srpm --distro=$(distro)

deb:
	@which debuild || \
		{ echo "Missing devscripts dependency. Install with:"; \
			echo sudo apt-get install devscripts; exit 1; }

	$(PYTHON) ./packages/bddeb

deb-src:
	@which debuild || \
		{ echo "Missing devscripts dependency. Install with:"; \
			echo sudo apt-get install devscripts; exit 1; }
	$(PYTHON) ./packages/bddeb -S -d

doc:
	tox -e doc

# Spell check && filter false positives
_CHECK_SPELLING := find doc -type f -exec spellintian {} + | \
       grep -v -e 'doc/rtd/topics/cli.rst: modules modules' \
               -e 'doc/examples/cloud-config-mcollective.txt: WARNING WARNING' \
               -e 'doc/examples/cloud-config-power-state.txt: Bye Bye' \
               -e 'doc/examples/cloud-config.txt: Bye Bye' \
               -e 'doc/rtd/topics/cli.rst: DOCS DOCS'


# For CI we require a failing return code when spellintian finds spelling errors
check_spelling:
	@! $(_CHECK_SPELLING)

# Manipulate the output of spellintian into a valid "sed" command which is run
# to fix the error
#
# Example spellintian output:
#
# doc/examples/kernel-cmdline.txt: everthing -> everything
#
# The "fix_spelling" target manipulates the above output into the following command
# and runs that command.
#
# sed -i "s/everthing/everything/g" doc/examples/kernel-cmdline.txt
#
# awk notes:
#
# -F ': | -> ' means use the strings ": " or " -> " as field delimeters
# \046 is octal for double quote
# $$2 will contain the second field, ($ must be escaped because this is in a Makefile)
#
# Limitation: duplicate words with newline between them are not automatically fixed
fix_spelling:
	@$(_CHECK_SPELLING) | \
		sed 's/ (duplicate word)//g' | \
		awk -F ': | -> ' '{printf "sed -i \047s/%s/%s/g\047 %s\n", $$2, $$3, $$1}' | \
		sh

.PHONY: all check test flake8 clean rpm srpm deb deb-src yaml
.PHONY: check_version pip-test-requirements pip-requirements clean_pyc
.PHONY: unittest style-check fix_spelling render-template benchmark-generator
.PHONY: clean_pytest clean_packaging check_spelling clean_release doc

=== debian/changelog ===
cloud-init (22.2-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Bastian Blank <waldi@debian.org>  Wed, 22 Jun 2022 11:56:52 +0200

cloud-init (22.2-1) unstable; urgency=medium

  [ Thomas Goirand ]
  * Removed prettytable and six from build-depends (Closes: #1009279).

  [ Noah Meyerhans ]
  * debian/watch: point to github as the canonical source repository
  * New upstream version 22.2
  * d/control: Add python3-responses and python3-pytest-mock build-deps
  * salsa-ci: allow reprotest to fail
  * Refresh patches

 -- Noah Meyerhans <noahm@debian.org>  Tue, 31 May 2022 12:44:24 -0700

cloud-init (21.4-3) unstable; urgency=medium

  * Fix VMware tests for ipv6-only.

 -- Bastian Blank <waldi@debian.org>  Tue, 29 Mar 2022 13:36:09 +0200

cloud-init (21.4-2) unstable; urgency=medium

  * Remove ifupdown and net-tools depends.
  * Require isc-dhcp-client as dhclient is used internally.

 -- Bastian Blank <waldi@debian.org>  Mon, 28 Mar 2022 11:56:22 +0200

cloud-init (21.4-1) unstable; urgency=medium

  * New upstream version 21.4 (Closes: 910654)

 -- Noah Meyerhans <noahm@debian.org>  Wed, 03 Nov 2021 10:44:32 -0700

cloud-init (21.3-2) unstable; urgency=medium

  * Refreshed debian/patches/cloud-init-before-chronyd.patch.
  * Add patch: fix-sources-list-for-security-in-bullseye-and-above.patch
    (Closes: #969934).

 -- Thomas Goirand <zigo@debian.org>  Sun, 24 Oct 2021 23:28:46 +0200

cloud-init (21.3-1) unstable; urgency=medium

  * New upstream version 21.3
  * Add python3-netifaces to build-deps
  * Install upstream man pages

 -- Noah Meyerhans <noahm@debian.org>  Thu, 26 Aug 2021 12:33:57 -0700

cloud-init (21.2-1) unstable; urgency=medium

  * New upstream version 21.2 (Closes: #991629, #979974)

 -- Noah Meyerhans <noahm@debian.org>  Thu, 12 Aug 2021 09:16:27 -0700

=== debian/control ===
Source: cloud-init
Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
Uploaders:
 Bastian Blank <waldi@debian.org>,
 Thomas Goirand <zigo@debian.org>,
 Noah Meyerhans <noahm@debian.org>,
Section: admin
Priority: optional
Build-Depends:
 debhelper (>= 10),
 dh-python,
 iproute2,
 po-debconf,
 pylint,
 python3-all,
 python3-pep8,
 python3-setuptools,
Build-Depends-Indep:
 python3-configobj,
 python3-contextlib2,
 python3-httpretty (>= 0.9.5),
 python3-jinja2,
 python3-jsonpatch,
 python3-jsonschema,
 python3-mock,
 python3-netifaces,
 python3-oauthlib,
 python3-pyflakes,
 python3-pytest,
 python3-pytest-mock,
 python3-requests,
 python3-responses,
 python3-serial,
 python3-unittest2,
 python3-yaml,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/cloud-team/cloud-init
Vcs-Git: https://salsa.debian.org/cloud-team/cloud-init.git
Homepage: https://launchpad.net/cloud-init

Package: cloud-init
Architecture: all
Depends:
 fdisk | util-linux (<< 2.29.2-3~),
 gdisk,
 isc-dhcp-client,
 locales,
 lsb-base,
 lsb-release,
 procps,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 cloud-guest-utils,
 eatmydata,
 sudo,
Suggests:
 btrfs-progs,
 e2fsprogs,
 xfsprogs,
Description: initialization system for infrastructure cloud instances
 Cloud-init provides a framework and tool to configure and customize virtual
 machine instances for Infrastructure-as-a-Service (IaaS) clouds platforms. It
 can for example set a default locale and hostname, generate SSH private host
 keys, install SSH public keys for logging into a default account, set up
 ephemeral mount points, and run user-provided scripts.
 .
 Various methods are supported for passing data to the instance at launch
 time, including the standard interfaces of multiple platforms.

=== debian/watch ===
version=3
https://github.com/canonical/cloud-init/tags .*/(\d+\.\d+).tar.gz

## cloud-init 22.3.4

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,6 @@
 YAML_FILES+=$(shell find doc/examples -name "cloud-config*.txt" -type f )
 
 PYTHON = python3
-PIP_INSTALL := pip3 install
 
 NUM_ITER ?= 100
 
@@ -55,14 +54,6 @@
 
 ci-deps-centos:
 	@$(PYTHON) $(CWD)/tools/read-dependencies --distro centos --test-distro
-
-pip-requirements:
-	@echo "Installing cloud-init dependencies..."
-	$(PIP_INSTALL) -r "$@.txt" -q
-
-pip-test-requirements:
-	@echo "Installing cloud-init test dependencies..."
-	$(PIP_INSTALL) -r "$@.txt" -q
 
 test: unittest
 
@@ -128,13 +119,20 @@
 doc:
 	tox -e doc
 
+fmt:
+	tox -e do_format && tox -e check_format
+
+fmt-tip:
+	tox -e do_format_tip && tox -e check_format_tip
+
 # Spell check && filter false positives
 _CHECK_SPELLING := find doc -type f -exec spellintian {} + | \
        grep -v -e 'doc/rtd/topics/cli.rst: modules modules' \
                -e 'doc/examples/cloud-config-mcollective.txt: WARNING WARNING' \
                -e 'doc/examples/cloud-config-power-state.txt: Bye Bye' \
                -e 'doc/examples/cloud-config.txt: Bye Bye' \
-               -e 'doc/rtd/topics/cli.rst: DOCS DOCS'
+               -e 'doc/rtd/topics/cli.rst: DOCS DOCS' \
+               -e 'dependant'
 
 
 # For CI we require a failing return code when spellintian finds spelling errors
@@ -167,6 +165,6 @@
 		sh
 
 .PHONY: all check test flake8 clean rpm srpm deb deb-src yaml
-.PHONY: check_version pip-test-requirements pip-requirements clean_pyc
+.PHONY: check_version clean_pyc
 .PHONY: unittest style-check fix_spelling render-template benchmark-generator
 .PHONY: clean_pytest clean_packaging check_spelling clean_release doc

=== debian/changelog ===
cloud-init (22.3.4-0ubuntu1~22.04.1) jammy; urgency=medium

  * New upstream bugfix release. (LP: #1987318)
    + Release 22.3.4 (LP: #1986703)
    + Fix Oracle DS primary interface when using IMDS (#1757)
      (LP: #1989686)

 -- Brett Holman <brett.holman@canonical.com>  Mon, 03 Oct 2022 10:17:12 -0600

cloud-init (22.3.3-0ubuntu1~22.04.1) jammy; urgency=medium

  * New upstream bugfix release. (LP: #1987318)
    + Release 22.3.3
    + Fix Oracle DS not setting subnet when using IMDS (#1735)
    + azure: define new attribute for pre-22.3 pickles (#1725)
    + sources/azure: ensure instance id is always correct (#1727)
      [Chris Patterson]

 -- Brett Holman <brett.holman@canonical.com>  Wed, 21 Sep 2022 14:27:01 -0600

cloud-init (22.3-13-g70ce6442-0ubuntu1~22.04.1) jammy; urgency=medium

  * d/control: add python3-debconf to Depends and Build-Depends
  * d/cloud-init.lintian-overrides: lintian fixes:
    + Fix systemd-service-file-refers-to-unusual-wantedby-target format.
  * d/cloud-init.postinst
    + Lintian: Fix command-with-path-in-maintainer-script for grub-install.
  * d/source/lintian-overrides: lintian fixes:
    + silence binary-nmu-debian-revision-in-source bug:
      https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1014584
  * d/p/expire-on-hashed-users.patch:
    Add patch to ensure password expire doesn't apply to hashed users
  * drop the following cherry-picks now included:
    + cpick-a2e62738-Fix-cc_phone_home-requiring-tries-1500
  * New upstream snapshot. (LP: #1987318)
    + Fix v2 interface matching when no MAC
    + test: reduce number of network dependencies in flaky test (#1702)
    + docs: publish cc_ubuntu_autoinstall docs to rtd (#1696)
    + net: Fix EphemeraIPNetwork (#1697)
    + test: make ansible test work across older versions (#1691)
    + Networkd multi-address support/fix (#1685) [Teodor Garzdin]
    + make: drop broken targets (#1688)
    + net: Passthough v2 netconfigs in netplan systems (#1650)
    + NM ipv6 connection does not work on Azure and Openstack (#1616)
      [Emanuele Giuseppe Esposito]
    + Fix check_format_tip (#1679)
    + DataSourceVMware: fix var use before init (#1674) [Andrew Kutz]
    + rpm/copr: ensure RPM represents new clean.d dir artifacts (#1680)
    + test: avoid centos leaked check of /etc/yum.repos.d/epel-testing.repo
      (#1676)
    + Release 22.3 (#1662)
    + sources: obj.pkl cache should be written anyime get_data is run
      (#1669)
    + schema: drop release number from version file (#1664)
    + pycloudlib: bump to quiet azure HTTP info logs (#1668)
    + test: fix wireguard integration tests (#1666)
    + Github is deprecating the 18.04 runner starting 12.1 (#1665)
    + integration tests: Ensure one setup for all tests (#1661)
    + tests: ansible test fixes (#1660)
    + Prevent concurrency issue in test_webhook_hander.py (#1658)
    + Workaround net_setup_link race with udev (#1655)
    + test: drop erroneous lxd assertion, verify command succeeded (#1657)
    + Fix Chrony usage on Centos Stream (#1648) [Sven Haardiek]
    + sources/azure: handle network unreachable errors for saveable PPS
      (#1642) [Chris Patterson]
    + Return cc_set_hostname to PER_INSTANCE frequency (#1651)
    + test: Collect integration test time by default (#1638)
    + test: Drop forced package install hack in lxd integration test
      (#1649)
    + schema: Resolve user-data if --system given (#1644)
      [Alberto Contreras]
    + test: use fake filesystem to avoid file removal (#1647)
      [Alberto Contreras]
    + tox: Fix tip-flake8 and tip-mypy (#1635) [Alberto Contreras]
    + config: Add wireguard config module (#1570)
      [Fabian Lichtenegger-Lukas]
    + tests: can run without azure-cli, tests expect inactive ansible
      (#1643)
    + typing: Type UrlResponse.contents (#1633) [Alberto Contreras]
    + testing: fix references to `DEPRECATED.` (#1641)
      [Alberto Contreras]
    + ssh_util: Handle sshd_config.d folder [Alberto Contreras]
    + schema: Enable deprecations in cc_update_etc_hosts (#1631)
      [Alberto Contreras]
    + Add Ansible Config Module (#1579)
    + util: Support Idle process state in get_proc_ppid() (#1637)
    + schema: Enable deprecations in cc_growpart (#1628)
      [Alberto Contreras]
    + schema: Enable deprecations in cc_users_groups (#1627)
      [Alberto Contreras]
    + util: Fix error path and parsing in get_proc_ppid()
    + main: avoid downloading full contents cmdline urls (#1606)
    + schema: Enable deprecations in cc_scripts_vendor (#1629)
      [Alberto Contreras]
    + schema: Enable deprecations in cc_set_passwords (#1630)
      [Alberto Contreras]
    + sources/azure: add experimental support for preprovisioned os disks
      (#1622) [Chris Patterson]
    + Remove configobj a_to_u calls (#1632) [Stefano Rivera]
    + cc_debug: Drop this module (#1614) [Alberto Contreras]
    + schema: add aggregate descriptions in anyOf/oneOf (#1636)
    + testing: migrate test_sshutil to pytest (#1617) [Alberto Contreras]
    + testing: Fix test_ca_certs integration test (#1626)
      [Alberto Contreras]
    + testing: add support for pycloudlib's pro images (#1604)
      [Alberto Contreras]
    + testing: migrate test_cc_set_passwords to pytest (#1615)
      [Alberto Contreras]
    + network: add system_info network activator cloud.cfg overrides
      (#1619)
    + docs: Align git remotes with uss-tableflip setup (#1624)
      [Alberto Contreras]
    + testing: cover active config module checks (#1609)
      [Alberto Contreras]
    + lxd: lvm avoid thinpool when kernel module absent
    + lxd: enable MTU configuration in cloud-init
    + doc: pin doc8 to last passing version
    + cc_set_passwords fixes (#1590)
    + Modernise importer.py and type ModuleDetails (#1605)
      [Alberto Contreras]
    + config: Def activate_by_schema_keys for t-z (#1613)
      [Alberto Contreras]
    + config: define activate_by_schema_keys for p-r mods (#1611)
      [Alberto Contreras]


=== debian/control ===
Source: cloud-init
Section: admin
Priority: optional
Homepage: https://cloud-init.io/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               iproute2,
               pep8,
               po-debconf,
               python3,
               python3-configobj,
               python3-debconf,
               python3-httpretty,
               python3-jinja2,
               python3-jsonpatch,
               python3-jsonschema,
               python3-mock,
               python3-netifaces,
               python3-oauthlib,
               python3-pytest,
               python3-pytest-mock,
               python3-requests,
               python3-serial,
               python3-setuptools,
               python3-yaml,
               python3-responses
XS-Python-Version: all
Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
Standards-Version: 4.5.0
Rules-Requires-Root: no

Package: cloud-init
Architecture: all
Depends: cloud-guest-utils | cloud-utils,
         isc-dhcp-client,
         iproute2,
         netplan.io,
         procps,
         python3,
         python3-debconf,
         python3-netifaces,
         python3-requests,
         python3-serial,
         ${misc:Depends},
         ${python3:Depends}
Recommends: eatmydata, gdisk, gnupg, software-properties-common
Suggests: openssh-server, ssh-import-id
XB-Python-Version: ${python:Versions}
Description: initialization and customization tool for cloud instances
 Cloud-init is the industry standard multi-distribution method for
 cross-platform cloud instance initialization. It is supported across all major
 public cloud providers, provisioning systems for private cloud infrastructure,
 and bare-metal installations.
 .
 Cloud instances are initialized from a disk image and instance data:
 .
  * Cloud metadata
  * User data (optional)
  * Vendor data (optional)
 .
 Cloud-init will identify the cloud it is running on during boot, read any
 provided metadata from the cloud and initialize the system accordingly. This
 may involve setting up the network and storage devices to configuring SSH
 access key and many other aspects of a system. Later on the cloud-init will
 also parse and process any optional user or vendor data that was passed to
 the instance.

## cloud-init 22.4.2

=== debian/changelog ===
cloud-init (22.4.2-1+deb12u3) bookworm; urgency=medium

  * Import upstream fix for CVE-2024-6174 (Closes: #1108403)
  * salsa-ci: build in bookworm
  * Backport upstream fix for CVE-2024-11584 (Closes: #1108402)

 -- Noah Meyerhans <noahm@debian.org>  Thu, 10 Jul 2025 15:07:51 -0400

cloud-init (22.4.2-1+deb12u2) bookworm; urgency=medium

  * networkd: Add support for multiple [Route] sections (Closes: #1052535)

 -- Noah Meyerhans <noahm@debian.org>  Tue, 17 Sep 2024 11:08:48 -0400

cloud-init (22.4.2-1+deb12u1) bookworm; urgency=medium

  * Add Conflicts/Replaces relationship on cloud-init-22.4.2

 -- Noah Meyerhans <noahm@debian.org>  Tue, 28 May 2024 13:23:38 -0700

cloud-init (22.4.2-1) unstable; urgency=medium

  [ Bastian Blank ]
  * Remove unused integration into rsyslog.
  * Remove unneeded config overrides.
  * Update main config from template

  [ Noah Meyerhans ]
  * d/watch: ignore ubuntu internal releases
  * New upstream version 22.4.2 (Closes: #1010555)
  * Refresh patches

 -- Noah Meyerhans <noahm@debian.org>  Tue, 13 Dec 2022 12:35:18 -0800

cloud-init (22.2-3) unstable; urgency=medium

  * Depend on eject for Azure data source.
  * Support APT automated mirror selection.
  * Update Debian default mirrors.

 -- Bastian Blank <waldi@debian.org>  Mon, 05 Sep 2022 15:29:28 +0200

cloud-init (22.2-2) unstable; urgency=high

  * CVE-2022-2084: logged schema failures can include password hashes. Applied
    upstream patch: Remove_schema_errors_from_log.patch (Closes: #1014247).

 -- Thomas Goirand <zigo@debian.org>  Sun, 03 Jul 2022 19:03:53 +0200

=== debian/control ===
Source: cloud-init
Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
Uploaders:
 Bastian Blank <waldi@debian.org>,
 Thomas Goirand <zigo@debian.org>,
 Noah Meyerhans <noahm@debian.org>,
Section: admin
Priority: optional
Build-Depends:
 debhelper (>= 10),
 dh-python,
 iproute2,
 po-debconf,
 pylint,
 python3-all,
 python3-pep8,
 python3-setuptools,
Build-Depends-Indep:
 python3-configobj,
 python3-contextlib2,
 python3-httpretty (>= 0.9.5),
 python3-jinja2,
 python3-jsonpatch,
 python3-jsonschema,
 python3-mock,
 python3-netifaces,
 python3-oauthlib,
 python3-pyflakes,
 python3-pytest,
 python3-pytest-mock,
 python3-requests,
 python3-responses,
 python3-serial,
 python3-unittest2,
 python3-yaml,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/cloud-team/cloud-init
Vcs-Git: https://salsa.debian.org/cloud-team/cloud-init.git
Homepage: https://launchpad.net/cloud-init

Package: cloud-init
Architecture: all
Conflicts: cloud-init-22.4.2
Replaces: cloud-init-22.4.2
Depends:
 eject,
 fdisk | util-linux (<< 2.29.2-3~),
 gdisk,
 isc-dhcp-client,
 locales,
 lsb-base,
 lsb-release,
 procps,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 cloud-guest-utils,
 eatmydata,
 sudo,
Suggests:
 btrfs-progs,
 e2fsprogs,
 xfsprogs,
Description: initialization system for infrastructure cloud instances
 Cloud-init provides a framework and tool to configure and customize virtual
 machine instances for Infrastructure-as-a-Service (IaaS) clouds platforms. It
 can for example set a default locale and hostname, generate SSH private host
 keys, install SSH public keys for logging into a default account, set up
 ephemeral mount points, and run user-provided scripts.
 .
 Various methods are supported for passing data to the instance at launch
 time, including the standard interfaces of multiple platforms.

=== debian/rules ===
#!/usr/bin/make -f

PYTHON3S:=$(shell py3versions -vr)
export PYBUILD_INSTALL_ARGS=--init-system=systemd,sysvinit_deb

%:
	dh $@ --with python3 --buildsystem pybuild

override_dh_auto_install:
	dh_auto_install
	mv $(CURDIR)/debian/cloud-init/etc/NetworkManager/dispatcher.d/hook-network-manager \
		$(CURDIR)/debian/cloud-init/etc/NetworkManager/dispatcher.d/cloud-init-hook-network-manager

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e && set -x && for pyvers in $(PYTHON3S); do \
		PYMAJOR=`echo $$pyvers | cut -d'.' -f1` ; \
		echo "===> Testing with python$$pyvers (python$$PYMAJOR)" ; \
		PYTHON=python$$pyvers PYTHONPATH=. python$$pyvers -m pytest -v tests/unittests --ignore-glob $(CURDIR)/tests/unittests/test_datasource/test_opennebula.py ; \
	done
endif

override_dh_installinit:
	dh_installinit --onlyscripts --no-start --no-restart-on-upgrade --name cloud-init-local
	dh_installinit --onlyscripts --no-start --no-restart-on-upgrade
	dh_installinit --onlyscripts --no-start --no-restart-on-upgrade --name cloud-config
	dh_installinit --onlyscripts --no-start --no-restart-on-upgrade --name cloud-final

override_dh_systemd_start:
	dh_systemd_start --no-restart-on-upgrade --no-start

## cloud-init 23.1.1

=== debian/changelog ===
cloud-init (23.1.1-0ubuntu2) lunar; urgency=medium

  * d/apport-general-hook.py: Add general apport hook to append cloud type,
    image and instance size information to bug reports (LP: #1724623)
  * d/cloud-init.postinst: MAAS prefer yaml.safe_load over yaml.load
    (LP: #2009746)
  * d/cloud-init.preinst: Oracle to remove vestigial /etc/cloud.cloud.cfg.d/
    99-disable-network-config.cfg because system config is now honored before
    datasource config (LP: #1956788)
  * Upstream snapshot based on upstream/main at 85b2fbc2.
    - Bugs fixed in this snapshot: (LP: #1956788)

 -- Chad Smith <chad.smith@canonical.com>  Tue, 21 Mar 2023 14:43:55 -0600

cloud-init (23.1.1-0ubuntu1) lunar; urgency=medium

  * Upstream snapshot based on main at 4896402b.

 -- James Falcon <james.falcon@canonical.com>  Thu, 02 Mar 2023 16:46:05 -0600

cloud-init (23.1-0ubuntu2) lunar; urgency=medium

  * Upstream snapshot based on main at d1ffbea5.
    - Bugs fixed in this snapshot: (LP: #2008727)

 -- James Falcon <james.falcon@canonical.com>  Thu, 02 Mar 2023 14:05:48 -0600

cloud-init (23.1-0ubuntu1) lunar; urgency=medium

  * Upstream snapshot based on 23.1.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.1/ChangeLog
    - Bugs fixed in this snapshot: (LP: #1990513, #1999164, #1931174)
      (LP: #1815990)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Wed, 22 Feb 2023 18:15:10 +0100

cloud-init (22.4.2-0ubuntu3) lunar; urgency=medium

  * Upstream snapshot based on upstream/main at bdc7b040.
    - Bugs fixed in this snapshot: (LP: #2001737, #1998526, #2000596)
      (LP: #1851438)
  * Upstream snapshot based on upstream/main at 3b8b4692.
    - Bugs fixed in this snapshot: (LP: #1998998, #1997922, #2002969)
      (LP: #2003562, #1999680)

 -- James Falcon <james.falcon@canonical.com>  Fri, 03 Feb 2023 15:36:12 -0600

cloud-init (22.4.2-0ubuntu2) lunar; urgency=medium

  * Upstream snapshot based on upstream/main at 040090a3.
    - Bugs fixed in this snapshot: (LP: #1994980, #1998655, #1999042)
      (LP: #1997559)

 -- Chad Smith <chad.smith@canonical.com>  Thu, 15 Dec 2022 16:11:37 -0700

cloud-init (22.4.2-0ubuntu1) lunar; urgency=medium

  * Upstream snapshot based on upstream commit 893df0d6.
    - Bugs fixed in this snapshot: (LP: #1997559)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Thu, 24 Nov 2022 08:39:08 +0100

cloud-init (22.4.1-0ubuntu1) lunar; urgency=medium

  * Upstream snapshot based on upstream commit c038808e.

 -- James Falcon <james.falcon@canonical.com>  Mon, 21 Nov 2022 15:02:34 -0600

cloud-init (22.4-0ubuntu4) lunar; urgency=medium

  * Upstream snapshot based on upstream commit 74ed1387.
    - Bugs fixed in this snapshot: (LP: #1844191, #1906849, #1992512)

 -- James Falcon <james.falcon@canonical.com>  Fri, 18 Nov 2022 16:41:49 -0600

cloud-init (22.4-0ubuntu3) lunar; urgency=medium

  * d/changelog: Sync released d/changelog entries
    - 22.3.4-0ubuntu1 and 22.3.3-0ubuntu1~22.10.1
  * Changelog: Sync release entries in Changlog:
    - 22.3.1, 22.3.2, 22.3.3 and 22.3.4

 -- Chad Smith <chad.smith@canonical.com>  Tue, 15 Nov 2022 19:08:24 -0700

cloud-init (22.4-0ubuntu2) lunar; urgency=medium

  * d/changelog: account for closed bugs released in 22.4-0ubuntu1

 -- Chad Smith <chad.smith@canonical.com>  Tue, 15 Nov 2022 16:34:07 -0700

cloud-init (22.4-0ubuntu1) lunar; urgency=medium

  * d/control: drop python3-httpretty from Build-Depends
  * d/cloud-init.templates: Add NWCS to datasource list
  * Upstream snapshot based on 22.4 upstream release. List of changes
    from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/22.4/ChangeLog
  * Bugs fixed in this snapshot:
    (LP: #1962343, #1913461, #1883122, #1989686, #1307667, #1990070, #1991567)
    (LP: #1991024, #1990041, #1993836)

 -- James Falcon <james.falcon@canonical.com>  Tue, 15 Nov 2022 14:23:44 -0600

cloud-init (22.3.4-0ubuntu1) kinetic; urgency=medium

  * New upstream bug fix release.
    + Release 22.3.4 (LP: #1986703)
    + Fix Oracle DS primary interface when using IMDS (#1757)
      (LP: #1989686)

 -- Brett Holman <brett.holman@canonical.com>  Fri, 30 Sep 2022 16:07:44 -0600

cloud-init (22.3.3-0ubuntu1~22.10.1) kinetic; urgency=medium

  * New upstream bug fix release.
    + Release 22.3.3 (LP: #1986703)
    + Fix Oracle DS not setting subnet when using IMDS (#1735)
      (LP: #1989686)
    + azure: define new attribute for pre-22.3 pickles (#1725)
    + sources/azure: ensure instance id is always correct (#1727)
      [Chris Patterson]

 -- Brett Holman <brett.holman@canonical.com>  Mon, 19 Sep 2022 13:13:06 -0600

cloud-init (22.3-13-g70ce6442-0ubuntu1~22.10.1) kinetic; urgency=medium

  * New upstream snapshot.
    + Fix v2 interface matching when no MAC (LP: #1986551)
    + test: reduce number of network dependencies in flaky test (#1702)
    + docs: publish cc_ubuntu_autoinstall docs to rtd (#1696)
    + net: Fix EphemeraIPNetwork (#1697)
    + test: make ansible test work across older versions (#1691)
    + Networkd multi-address support/fix (#1685) [Teodor Garzdin]
    + make: drop broken targets (#1688)
    + net: Passthough v2 netconfigs in netplan systems (#1650)
      (LP: #1978543)
    + NM ipv6 connection does not work on Azure and Openstack (#1616)
      [Emanuele Giuseppe Esposito]
    + Fix check_format_tip (#1679)

 -- Brett Holman <brett.holman@canonical.com>  Tue, 30 Aug 2022 14:28:27 -0600

cloud-init (22.3-3-g9f0efc47-0ubuntu1~22.10.1) kinetic; urgency=medium

  * New upstream snapshot.
    + DataSourceVMware: fix var use before init (#1674) (LP: #1987005)
      [Andrew Kutz]
    + rpm/copr: ensure RPM represents new clean.d dir artifacts (#1680)
    + test: avoid centos leaked check of /etc/yum.repos.d/epel-testing.repo
      (#1676)
    + typo correction in Changelog

 -- Chad Smith <chad.smith@canonical.com>  Tue, 23 Aug 2022 14:30:10 -0600



## cloud-init 23.1.2

=== Makefile ===
--- 
+++ 
@@ -4,13 +4,11 @@
 YAML_FILES=$(shell find cloudinit tests tools -name "*.yaml" -type f )
 YAML_FILES+=$(shell find doc/examples -name "cloud-config*.txt" -type f )
 
-PYTHON = python3
+PYTHON ?= python3
 
 NUM_ITER ?= 100
 
-ifeq ($(distro),)
-  distro = redhat
-endif
+distro ?= redhat
 
 READ_VERSION=$(shell $(PYTHON) $(CWD)/tools/read-version || echo read-version-failed)
 CODE_VERSION=$(shell $(PYTHON) -c "from cloudinit import version; print(version.version_string())")
@@ -29,7 +27,7 @@
 	@$(CWD)/tools/run-flake8
 
 unittest: clean_pyc
-	python3 -m pytest -v tests/unittests cloudinit
+	$(PYTHON) -m pytest -v tests/unittests cloudinit
 
 render-template:
 	$(PYTHON) ./tools/render-cloudcfg --variant=$(VARIANT) $(FILE) $(subst .tmpl,,$(FILE))

=== requirements.txt ===
# Pypi requirements for cloud-init to work

# Used for untemplating any files or strings with parameters.
jinja2

# This one is currently only used by the MAAS datasource. If that
# datasource is removed, this is no longer needed
oauthlib

# This one is currently used only by the CloudSigma and SmartOS datasources.
# If these datasources are removed, this is no longer needed.
#
pyserial

# This is only needed for places where we need to support configs in a manner
# that the built-in config parser is not sufficent (ie
# when we need to preserve comments, or do not have a top-level
# section)...
configobj>=5.0.2

# All new style configurations are in the yaml format
pyyaml

# Requests handles ssl correctly!
requests

# For patching pieces of cloud-config together
jsonpatch

# For validating cloud-config sections per schema definitions
jsonschema

# Used by DataSourceVMware to inspect the host's network configuration during
# the "setup()" function.
#
# This allows a host that uses DHCP to bring up the network during BootLocal
# and still participate in instance-data by gathering the network in detail at
# runtime and merge that information into the metadata and repersist that to
# disk.
netifaces>=0.10.4

=== debian/changelog ===
cloud-init (23.1.2-0ubuntu0~18.04.1) bionic; urgency=medium

  * SECURITY UPDATE: Make user/vendor data sensitive and remove log permissions
    Because user data and vendor data may contain sensitive information,
    this commit ensures that any user data or vendor data written to
    instance-data.json gets redacted and is only available to root user.

    Also, modify the permissions of cloud-init.log to be 640, so that
    sensitive data leaked to the log isn't world readable.
    Additionally, remove the logging of user data and vendor data to
    cloud-init.log from the Vultr datasource.

    This is based on upstream snapshot of 23.1.2 [(LP: #2013967)]

    - d/cloud-init.postinst: postinst fixes for LP: #2013967
      Redact sensitive keys from world-readable instance-data.json on upgrade.
      Set perms 640 for /var/log/cloud-init.log on pkg upgrade.
      Redact sensitive Vultr messages from /var/log/cloud-init.log
    - (CVE-2023-1786)

 -- James Falcon <james.falcon@canonical.com>  Fri, 21 Apr 2023 14:44:30 -0500

cloud-init (23.1.1-0ubuntu0~18.04.1) bionic; urgency=medium

  * d/patches/netplan99-cannot-use-default.patch:
    - Retain routes' definitions compatible with netplan 0.99
  * d/patches/retain-netplan-world-readable.patch:
    - Retain original world-readable perms of /etc/netplan/50-cloud-init.yaml.
      Lunar made the config root read-only.
  * refresh patches:
    + debian/patches/expire-on-hashed-users.patch
  * Upstream snapshot based on 23.1.1. (LP: #2008230).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.1.1/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Fri, 03 Mar 2023 10:03:11 +0100

cloud-init (22.4.2-0ubuntu0~18.04.1) bionic; urgency=medium

  * Upstream snapshot based on 22.4.2 upstream release. (LP: #1996645)
    - List of changes from upstream can be found at
      https://raw.githubusercontent.com/canonical/cloud-init/22.4.2/ChangeLog
    - Includes (LP: #1997559, #1844191) not present in 22.4.0.

 -- James Falcon <james.falcon@canonical.com>  Mon, 28 Nov 2022 10:50:30 -0600

cloud-init (22.4-0ubuntu0~18.04.1) bionic; urgency=medium

  * d/control: drop python3-httpretty from Build-Depends
  * d/cloud-init.templates: Add NWCS to datasource list
  * refresh patches:
    + debian/patches/expire-on-hashed-users.patch
  * Upstream snapshot based on 22.4 upstream release. (LP: #1996645)
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/22.4/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 15 Nov 2022 16:21:48 -0600

cloud-init (22.3.4-0ubuntu1~18.04.1) bionic; urgency=medium

  * New upstream bugfix release. (LP: #1987318)
    + Release 22.3.4 (LP: #1986703)
    + Fix Oracle DS primary interface when using IMDS (#1757)
      (LP: #1989686)

 -- Brett Holman <brett.holman@canonical.com>  Mon, 03 Oct 2022 10:57:17 -0600

cloud-init (22.3.3-0ubuntu1~18.04.1) bionic; urgency=medium

  * New upstream bugfix release. (LP: #1987318)
    + Release 22.3.3
    + Fix Oracle DS not setting subnet when using IMDS (#1735)
    + azure: define new attribute for pre-22.3 pickles (#1725)
    + sources/azure: ensure instance id is always correct (#1727)
      [Chris Patterson]

 -- Brett Holman <brett.holman@canonical.com>  Wed, 21 Sep 2022 14:12:15 -0600

cloud-init (22.3-13-g70ce6442-0ubuntu1~18.04.1) bionic; urgency=medium

  * d/control: add python3-debconf to Depends and Build-Depends
  * d/cloud-init.postinst:
    + Lintian: Fix command-with-path-in-maintainer-script for grub-install
  * d/p/renderer-do-not-prefer-netplan refresh to activators change
  * d/p/expire-on-hashed-users.patch:
    Add patch to ensure password expire doesn't apply to hashed users
  * d/source/lintian-overrides: lintian fixes:
    + silence binary-nmu-debian-revision-in-source bug:
      https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1014584
  * refresh patches:
    + debian/patches/ec2-dont-apply-full-imds-network-config.patch
    + debian/patches/openstack-no-network-config.patch
    + debian/patches/renderer-do-not-prefer-netplan.patch
  * drop the following cherry-picks now included:
    + cpick-a2e62738-Fix-cc_phone_home-requiring-tries-1500
  * New upstream snapshot. (LP: #1987318)
    + Fix v2 interface matching when no MAC
    + test: reduce number of network dependencies in flaky test (#1702)
    + docs: publish cc_ubuntu_autoinstall docs to rtd (#1696)
    + net: Fix EphemeraIPNetwork (#1697)
    + test: make ansible test work across older versions (#1691)
    + Networkd multi-address support/fix (#1685) [Teodor Garzdin]
    + make: drop broken targets (#1688)
    + net: Passthough v2 netconfigs in netplan systems (#1650)
    + NM ipv6 connection does not work on Azure and Openstack (#1616)
      [Emanuele Giuseppe Esposito]
    + Fix check_format_tip (#1679)
    + DataSourceVMware: fix var use before init (#1674) [Andrew Kutz]
    + rpm/copr: ensure RPM represents new clean.d dir artifacts (#1680)
    + test: avoid centos leaked check of /etc/yum.repos.d/epel-testing.repo
      (#1676)
    + Release 22.3 (#1662)
    + sources: obj.pkl cache should be written anyime get_data is run
      (#1669)
    + schema: drop release number from version file (#1664)
    + pycloudlib: bump to quiet azure HTTP info logs (#1668)
    + test: fix wireguard integration tests (#1666)
    + Github is deprecating the 18.04 runner starting 12.1 (#1665)
    + integration tests: Ensure one setup for all tests (#1661)
    + tests: ansible test fixes (#1660)
    + Prevent concurrency issue in test_webhook_hander.py (#1658)
    + Workaround net_setup_link race with udev (#1655)
    + test: drop erroneous lxd assertion, verify command succeeded (#1657)
    + Fix Chrony usage on Centos Stream (#1648)
      [Sven Haardiek]
    + sources/azure: handle network unreachable errors for saveable PPS
      (#1642) [Chris Patterson]


=== debian/control ===
Source: cloud-init
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 9.20160709),
               dh-python,
               iproute2,
               pep8,
               po-debconf,
               python3,
               python3-configobj,
               python3-debconf,
               python3-jinja2,
               python3-jsonpatch,
               python3-jsonschema,
               python3-mock,
               python3-netifaces,
               python3-oauthlib,
               python3-pytest,
               python3-pytest-mock,
               python3-requests,
               python3-serial,
               python3-setuptools,
               python3-yaml,
               python3-responses
XS-Python-Version: all
Vcs-Browser: https://git.launchpad.net/cloud-init/?h=ubuntu/devel
Vcs-Git: git://git.launchpad.net/cloud-init -b ubuntu/devel
Standards-Version: 3.9.8

Package: cloud-init
Architecture: all
Depends: cloud-guest-utils | cloud-utils,
         isc-dhcp-client,
         iproute2,
         netplan.io | ifupdown,
         procps,
         python3,
         python3-debconf,
         python3-netifaces,
         python3-requests,
         python3-serial,
         ${misc:Depends},
         ${python3:Depends}
Recommends: eatmydata, gdisk, software-properties-common
Suggests: openssh-server, ssh-import-id
XB-Python-Version: ${python:Versions}
Description: Init scripts for cloud instances
 Cloud instances need special scripts to run during initialisation
 to retrieve and install ssh keys and to let the user run various scripts.

=== debian/rules ===
#!/usr/bin/make -f
INIT_SYSTEM ?= systemd
export PYBUILD_INSTALL_ARGS=--init-system=$(INIT_SYSTEM)
DEB_VERSION := $(shell dpkg-parsechangelog --show-field=Version)

%:
	dh $@ --with python3,systemd --buildsystem pybuild

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	http_proxy= make PYVER=python3 check
else
	@echo check disabled by DEB_BUILD_OPTIONS=$(DEB_BUILD_OPTIONS)
endif

override_dh_systemd_start:
	dh_systemd_start --no-restart-on-upgrade --no-start

override_dh_auto_install:
	dh_auto_install --destdir=debian/cloud-init
	install -D -m 0644 ./tools/21-cloudinit.conf debian/cloud-init/etc/rsyslog.d/21-cloudinit.conf
	install -D ./tools/Z99-cloud-locale-test.sh debian/cloud-init/etc/profile.d/Z99-cloud-locale-test.sh
	install -D ./tools/Z99-cloudinit-warnings.sh debian/cloud-init/etc/profile.d/Z99-cloudinit-warnings.sh
	install -m 0644 -D debian/apport-launcher.py debian/cloud-init/usr/share/apport/package-hooks/cloud-init.py
	flist=$$(find $(CURDIR)/debian/ -type f -name version.py) && sed -i 's,@@PACKAGED_VERSION@@,$(DEB_VERSION),' $${flist:-did-not-find-version-py-for-replacement}

## cloud-init 23.2.1

=== debian/changelog ===
cloud-init (23.2.1-0ubuntu0~22.10.1) kinetic; urgency=medium

  * Upstream snapshot based on 23.2.1. (LP: #2025180).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2.1/ChangeLog

 -- Brett Holman <brett.holman@canonical.com>  Wed, 28 Jun 2023 14:24:21 -0600

cloud-init (23.2-0ubuntu0~22.10.1) kinetic; urgency=medium

  * d/control: Remove pep8 dependency. It is no longer used.
  * d/apport-general-hook.py: Add general apport hook to append cloud type,
    image and instance size information to bug reports (LP: #1724623)
  * d/cloud-init.preinst: Oracle to remove vestigial /etc/cloud.cloud.cfg.d/
    99-disable-network-config.cfg because system config is now honored before
    datasource config (LP: #1956788)
  * d/cloud-init.preinst: Clean up vestigial
    /etc/cloud/cloud.cfg.d/99-disable-network-activation.cfg on GCE instances
    after fix in upstream google-guest-agent.
  * Upstream snapshot based on 23.2. (LP: #2023110).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2/ChangeLog

 -- Chad Smith <chad.smith@canonical.com>  Wed, 07 Jun 2023 02:04:42 -0600

cloud-init (23.1.1-0ubuntu0~22.10.1) kinetic; urgency=medium

  * d/patches/retain-netplan-world-readable.patch:
    - Retain original world-readable perms of /etc/netplan/50-cloud-init.yaml.
      Lunar made the config root read-only.
  * Upstream snapshot based on 23.1.1. (LP: #2008230).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.1.1/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Thu, 02 Mar 2023 12:02:34 -0600

cloud-init (22.4.2-0ubuntu0~22.10.1) kinetic; urgency=medium

  * Upstream snapshot based on 22.4.2 upstream release. (LP: #1996645)
    - List of changes from upstream can be found at
      https://raw.githubusercontent.com/canonical/cloud-init/22.4.2/ChangeLog
    - Includes (LP: #1997559, #1844191) not present in 22.4.0.

 -- James Falcon <james.falcon@canonical.com>  Mon, 28 Nov 2022 10:45:45 -0600

cloud-init (22.4-0ubuntu0~22.10.1) kinetic; urgency=medium

  * d/control: drop python3-httpretty from Build-Depends
  * d/cloud-init.templates: Add NWCS to datasource list
  * Upstream snapshot based on 22.4 upstream release. (LP: #1996645)
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/22.4/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 15 Nov 2022 15:30:01 -0600

=== debian/control ===
Source: cloud-init
Section: admin
Priority: optional
Homepage: https://cloud-init.io/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               iproute2,
               po-debconf,
               python3,
               python3-configobj,
               python3-debconf,
               python3-jinja2,
               python3-jsonpatch,
               python3-jsonschema,
               python3-mock,
               python3-netifaces,
               python3-oauthlib,
               python3-pytest,
               python3-pytest-mock,
               python3-requests,
               python3-serial,
               python3-setuptools,
               python3-yaml,
               python3-responses
Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
Standards-Version: 4.5.0
Rules-Requires-Root: no

Package: cloud-init
Architecture: all
Depends: cloud-guest-utils | cloud-utils,
         isc-dhcp-client,
         iproute2,
         netplan.io,
         procps,
         python3,
         python3-debconf,
         python3-netifaces,
         python3-requests,
         python3-serial,
         ${misc:Depends},
         ${python3:Depends}
Recommends: eatmydata, gdisk, gnupg, software-properties-common
Suggests: openssh-server, ssh-import-id
Description: initialization and customization tool for cloud instances
 Cloud-init is the industry standard multi-distribution method for
 cross-platform cloud instance initialization. It is supported across all major
 public cloud providers, provisioning systems for private cloud infrastructure,
 and bare-metal installations.
 .
 Cloud instances are initialized from a disk image and instance data:
 .
  * Cloud metadata
  * User data (optional)
  * Vendor data (optional)
 .
 Cloud-init will identify the cloud it is running on during boot, read any
 provided metadata from the cloud and initialize the system accordingly. This
 may involve setting up the network and storage devices to configuring SSH
 access key and many other aspects of a system. Later on the cloud-init will
 also parse and process any optional user or vendor data that was passed to
 the instance.
